################################################################################
# Macro: gera_arq_servicos.gml
#
# Descr:
#		
# Data : 24/10/2003           Autor: Rogerio Candelaria
# 
# Param:	
#
# Alter:
################################################################################

open database $p1 $p2 named db;

open file /tmp/servicos_$p3..txt write named arq;

time get_system_time;
time_day := 01;
time_month := $p3;
time_year := 2003;
time_hour := 0;
time_minute := 0;
time_second := 0;
time time_to_oracle data_ini;

time_month := ($p3 + 1);
time time_to_oracle data_fim;

mess {data: $data_ini $data_fim};
create query ocor select PID, COD_EQP_OCOR, NUM_OPER_CHV_OCOR, DATA_ENCER_OCOR from ocorrencia 
where COD_EST_OCOR in (3,7,8,9,10) and DATA_ENCER_OCOR between 
to_date('$data_ini', 'dd-mon-yyyy hh24:mi:ss') and 
to_date('$data_fim', 'dd-mon-yyyy hh24:mi:ss')
and NUM_OPER_CHV_OCOR > 0 ;

activate ocor;
next ocor;

while ($ocor_end = no)
{
	tot_cons := 0;
	select NUM_OPER_PT_HDESPT from historico_deslig_posto 
	where PID_OCOR_HDESPT = '$ocor_col_1'
	named numpt
	process '
		select 	QTDE_CONS_RESID_PT, QTDE_CONS_COMERC_PT, QTDE_CONS_INDUST_PT, QTDE_CONS_PODER_PUBL_PT, 
			QTDE_CONS_RURAL_PT, QTDE_CONS_SERV_PUBL_PT, QTDE_CONS_PROPR_PT
		from posto where NUM_OPER_PT = \'$numpt_col_1\'
		named pt;
		
		tot_cons := $tot_cons + $pt_col_1 + $pt_col_2 + $pt_col_3 + $pt_col_4 + $pt_col_5 + $pt_col_6 + $pt_col_7;			
	';
	
	#mess {$ocor_col_2;$ocor_col_3;$ocor_col_4;};
	switch $ocor_col_2
	case C
	{
		chv_dest := $ocor_col_3;
	}
	case T
	{
		select NUM_BLOCO_PT from posto
		where NUM_OPER_PT = '$ocor_col_3'
		named chv;

		chv_dest := $chv_col_1;
	}
	case U
	{
		tot_cons := 1;
		select FEAT_NUM_PT_CAD_CONS from consumidor
		where cdc_cons = $ocor_col_3
		named cons;
		
		select NUM_BLOCO_PT from posto
		where NUM_CAD_PT = $cons_col_1
		named chv;

		chv_dest := $chv_col_1;
	};
	
	select 	24*(DTHR_INIC_SRV-DTHR_SAIDA_SRV), NUM_SRV, (KM_ODOM_RETOR_SRV-KM_ODOM_SAIDA_SRV), PID_EQPC_SRV, 
		to_char(DTHR_TERM_SRV,'dd-mon-yyyy hh24:mi:ss')
	from servico where PID_OCOR_SRV = '$ocor_col_1' and INDIC_EST_SERV_SRV != 5
	named srv
	process '
		#mess {$srv_col_5};
		select pid_ocor_srv, NUM_SRV from servico 
		where PID_EQPC_SRV = \'$srv_col_4\' 
		and DTHR_TERM_SRV < to_date(\'$srv_col_5\', \'dd-mon-yyyy hh24:mi:ss\')
		and NUM_SRV != $srv_col_2
		order by DTHR_TERM_SRV desc
		named ocorOrig;
		
		if $ocorOrig_count = 0 then
		{
			chv_orig := \'\';
		}
		else
		{	
			select COD_EQP_OCOR, NUM_OPER_CHV_OCOR from ocorrencia 
			where PID = \'$ocorOrig_col_1\'
			named ocorOrig2;
		
			#mess {$ocorOrig2_col_1,$ocorOrig2_col_2,};
		
			switch $ocorOrig2_col_1
			case C
			{
				chv_orig := $ocorOrig2_col_2;
			}
			case T
			{
				select NUM_BLOCO_PT from posto
				where NUM_OPER_PT = \'$ocorOrig2_col_2\'
				named chv;

				chv_orig := $chv_col_1;
			}
			case U
			{
				if $ocorOrig2_col_2 != 0 then
				{
					select FEAT_NUM_PT_CAD_CONS from consumidor
					where cdc_cons = $ocorOrig2_col_2
					named cons;
		
					select NUM_BLOCO_PT from posto
					where NUM_CAD_PT = $cons_col_1
					named chv;
	
					chv_orig := $chv_col_1;
				};
			};
		};
		
		linha := $srv_col_2 ||{:}|| $chv_orig ||{:}|| $chv_dest ||{:}|| round($srv_col_3,2);
		linha := $linha ||{:}|| round($srv_col_1,2) ||{:}|| $tot_cons ||{:}|| $ocor_col_2 ||{:}|| $ocorOrig_col_2;
		#mess $linha;
		
		if $ocorOrig2_col_2 != 0 then
		{
			write to arq $linha;
		};
	';
	
	next ocor;
};

close object db, arq;